<?php
/**
 * @package WordPress
 * @subpackage Starkers
 */

automatic_feed_links();

function post_is_in_descendant_category( $cats, $_post = null ) {
	foreach ( (array) $cats as $cat ) {
		$descendants = get_term_children( (int) $cat, 'category');
		if ( $descendants && in_category( $descendants, $_post ) )
			return true;
	}
	return false;
}

?>
<?php
$key = "Ph";
$meta_boxes = array(
	"postimage" => array(
		"name" => "postimage",
		"title" => "Post image",
		"description" => "Using the \"<em>Add an Image</em>\" button, upload an image and paste the URL here. Post image is used as thumbnail within blog posts and as big photo for portfolio section."
	)
);

function create_meta_box() {
	global $key;

	if( function_exists( 'add_meta_box' ) ) {
		add_meta_box( 'new-meta-boxes', ucfirst( $key ) . ' Custom Post Options', 'display_meta_box', 'post', 'normal', 'high' );
	}
}

function display_meta_box() {
	global $post, $meta_boxes, $key;
?>
<div class="form-wrap">
<?php
	wp_nonce_field( plugin_basename( __FILE__ ), $key . '_wpnonce', false, true );

	foreach($meta_boxes as $meta_box) {
		$data = get_post_meta($post->ID, $key, true);
?>
    <div class="form-field form-required">
        <label for="<?php echo $meta_box[ 'name' ]; ?>"><?php echo $meta_box[ 'title' ]; ?></label>
        <input type="text" name="<?php echo $meta_box[ 'name' ]; ?>" value="<?php echo htmlspecialchars( $data[ $meta_box[ 'name' ] ] ); ?>" />
        <p><?php echo $meta_box[ 'description' ]; ?></p>
    </div>
<?php } ?>
</div>
<?php
} #end display_meta_box()

function save_meta_box( $post_id ) {
	global $post, $meta_boxes, $key;

	foreach( $meta_boxes as $meta_box ) {
		$data[ $meta_box[ 'name' ] ] = $_POST[ $meta_box[ 'name' ] ];
	}

	if ( !wp_verify_nonce( $_POST[ $key . '_wpnonce' ], plugin_basename(__FILE__) ) )
	return $post_id;

	if ( !current_user_can( 'edit_post', $post_id ))
	return $post_id;

	update_post_meta( $post_id, $key, $data );
}

add_action( 'admin_menu', 'create_meta_box' );
add_action( 'save_post', 'save_meta_box' );


?>
<?php
/* Custom comments */
function mytheme_comment($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class(); ?> id="comment-<?php comment_ID() ?>">
		<div id="div-comment-<?php comment_ID(); ?>" class="s">

			<div class="comment-meta commentmetadata commentdata">
            	<?php echo get_avatar( $comment, 80, get_bloginfo("template_directory")."/images/gravatar.jpg"); ?>
	
				<span class="comment_author_date">by <?php printf(__('%s'), get_comment_author_link()) ?> on <a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>" title=""><?php comment_date('F j') ?></a></span>
				<?php if ($comment->comment_approved == '0') : ?>
				<p class="comment_moderation"><em><?php _e('Your comment is awaiting moderation.') ?></em></p>
				<?php endif; ?>
			
				<?php comment_text() ?>
			
				 <!--[if IE 6]><cite>&nbsp;</cite><![endif]-->
                <p class="comment_details"><span class="replylink"><?php edit_comment_link('Edit','',''); ?> <?php comment_reply_link(array_merge( $args, array('reply_text' => 'Reply', 'depth' => $depth, 'max_depth' => $args['max_depth']))) ?></span></p>
	
			</div>
	
		</div>

<?php
}
?>
<?php
/* Options Page */
$themename = "Delicious photography";
$shortname = "tf";

$options = array (

	array(	"name" => "Theme common settings",
			"type" => "title"),
			
	array(	"type" => "open"),
	
	array(	"name" => "Logotype",
			"desc" => "Paste url to your logotype",
			"id" => $shortname."_logotype",
			"std" => "",
			"type" => "text"),
	
	array(	"name" => "Google Analytics",
			"desc" => "Enter your Google Analytics Code. Example: UA-123456-7",
			"id" => $shortname."_google",
			"std" => "",
			"type" => "text"),
	
	array(	"name" => "Photo categories",
			"desc" => "Enter cateries ID which to show as a gallery. Separate with comma. Example: 5,3,9,14",
			"id" => $shortname."_gallery",
			"std" => "",
			"type" => "text"),
			
	array(	"name" => "Theme color",
			"desc" => "Choose your theme color.",
			"id" => $shortname."_theme_color",
			"std" => "",
			"type" => "colorpicker"),
	
	array(	"name" => "Background color",
			"desc" => "Choose background color.",
			"id" => $shortname."_bg_color",
			"std" => "",
			"type" => "colorpicker"),
			
	array(	"name" => "Link color",
			"desc" => "Choose color the link",
			"id" => $shortname."_link_color",
			"std" => "",
			"type" => "colorpicker"),
	
	array(	"type" => "close"),
	
	array(	"name" => "Social profiles",
			"type" => "title"),
			
	array(	"type" => "open"),
	
	array(	"name" => "Twitter",
			"desc" => "Enter your twitter username",
			"id" => $shortname."_twitter",
			"std" => "",
			"type" => "text"),
	
	array(	"name" => "Flickr profile",
			"desc" => "Enter your flickr profile url",
			"id" => $shortname."_flickr",
			"std" => "",
			"type" => "text"),
			
	array(	"name" => "Facebook",
			"desc" => "Enter your facebook address",
			"id" => $shortname."_facebook",
			"std" => "",
			"type" => "text"),

	array(	"name" => "Youtube",
			"desc" => "Enter your youtube profile url",
			"id" => $shortname."_youtube",
			"std" => "",
			"type" => "text"),

	array(	"type" => "close"),
		
	array(	"name" => "CSS Control",
			"type" => "title"),
	array(	"type" => "open"),
	
	array(	"name" => "CSS Code",
			"desc" => 'You can easily override default CSS with your own. Note: Use carefully it may brake themes layout.',
            "id" => $shortname."_css",
            "type" => "textarea"),
				
	array(	"type" => "close")
	
);

function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); }

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Options", "".$themename." Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
    
?>
<div class="wrap">
<h2><?php echo $themename; ?> settings</h2>

<form method="post">

<?php foreach ($options as $value) { 
    
	switch ( $value['type'] ) {
	
		case "open":
		?>
        <table width="100%" border="0" style="background-color:#F1F1F1; padding:10px;">
		<?php break;
		
		case "close":
		?>
        </table><br />
        
		<?php break;
		
		case "title":
		?>
		<table width="100%" border="0" style="background-color:#464646; padding:5px 10px;">
        	<tr>
        		<td colspan="2"><h3 style="font-family:Georgia,'Times New Roman',Times,serif; color:#ffffff; color:#ffffff;"><?php echo $value['name']; ?></h3></td>
	        </tr>
        
		<?php break;

		case 'text':
		?>
        
        <tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%"><input style="width:400px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'] )); } else { echo $value['std']; } ?>" /></td>
        </tr>

        <tr>
            <td><small><?php echo $value['desc']; ?></small></td>
        </tr>
        <tr>
        	<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>
        
        <?php 
		break;
		
		case 'textarea':
		?>
        
        <tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%"><textarea name="<?php echo $value['id']; ?>" style="width:400px; height:100px;" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'] )); } else { echo $value['std']; } ?></textarea></td>
        </tr>
        <tr>
            <td><small><?php echo $value['desc']; ?></small></td>
        </tr>
        <tr>
        	<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>

		<?php 
		break;
		
		case 'select':
		?>
        <tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%"><select style="width:400px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>"><?php foreach ($value['options'] as $option) { ?><option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?></select></td>
       </tr>
                
       <tr>
            <td><small><?php echo $value['desc']; ?></small></td>
       </tr>
       <tr>
			<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>

		<?php
        break;
            
		case "checkbox":
		?>
        <tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%"><? if(get_settings($value['id'])){ $checked = "checked=\"checked\""; } else { $checked = ""; } ?>
				<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
			</td>
		</tr>
                        
        <tr>
        	<td><small><?php echo $value['desc']; ?></small></td>
		</tr>
        <tr>
        	<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>
            
        <?php break;
	
		case 'category':
		?>
		<tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
          	<td width="80%">
            	<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
					<?php $categories = get_categories('hide_empty=0');
                    foreach ($categories as $category) { ?>					
                    <option value="<?php echo $category->name; ?>" <?php if ( get_settings( $value['id'] ) == $category->name){echo "selected=\"selected\"";} ?>><?php echo $category->name; ?></option>
                    <?php } ?>
				</select>
			</td>
		</tr>
                        
        <tr>
        	<td><small><?php echo $value['desc']; ?></small></td>
		</tr>
        <tr>
        	<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>
        <?php break;
		
		case 'page':
		?>
		<tr>
        	<td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%">
            	<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
				<?php $pages = get_pages();
                foreach ($pages as $page) { ?>
                	<option value="<?php echo $page->post_title; ?>" <?php if ( get_settings( $value['id'] ) == $page->post_title){echo "selected=\"selected\"";} ?>><?php echo $page->post_title; ?></option>
				<?php } ?>
                </select>
			</td>
		</tr>
        <tr>
      		<td><small><?php echo $value['desc']; ?></small></td>
		</tr>
        <tr>
        	<td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td>
		</tr>
        <tr>
        	<td colspan="2">&nbsp;</td>
		</tr>
        <?php break;
		
		
		case 'colorpicker':
		?>
        <link rel="stylesheet" media="screen" type="text/css" href="<?php echo get_bloginfo("template_directory"); ?>/css/colorpicker.css" />
        <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js"></script>
   		<script type="text/javascript" src="<?php echo get_bloginfo("template_directory"); ?>/js/colorpicker.js"></script>
        
		<script type="text/javascript" src="<?php echo get_bloginfo("template_directory"); ?>/js/admin_js.js"></script>

        <tr>
            <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
            <td width="80%"><input class="colorpickerfield" style="width:400px; background-color:<?php echo get_settings($value['id']); ?>" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'] )); } else { echo $value['std']; } ?>" />
            </td>
        </tr>

        <tr>
            <td><small><?php echo $value['desc']; ?></small></td>
        </tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>
        
        <?php 
		break;
		
} 
}
?>
<!--</table>-->
<p class="submit">
<input name="save" type="submit" value="Save changes" />    
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

<?php
}
add_action('admin_menu', 'mytheme_add_admin'); ?>